-- **************************************************************************
--   TitanPals.lua
--
--   By: KanadiaN
--        (Lindarena@Laughing Skull)
-- **************************************************************************

local L = LibStub( "AceLocale-3.0" ):GetLocale( "Titan", true );
local LB = LibStub( "AceLocale-3.0" ):GetLocale( "TitanPals", true );

-- **************************************************************************
-- NAME : TitanPals_Init( state )
-- DESC : For first time addon use
-- **************************************************************************
function TitanPals_Init( state )
     if ( state == "checkDB" ) then
          checkDB = true;
          TitanPalsInit = false;
     elseif ( state == "init" ) then
          checkDB = false;
     end
     if ( type( TitanPals ) ~= "table" ) then TitanPals = {}; end
     if ( TitanPalsInit ~= true ) then
          if ( checkDB ) then TitanPals_DebugUtils( "info", "reset", LB["TITAN_PALS_MENU_CHECKDB"] ); end
	  if ( not TitanPalsLists or TitanPalsLists == nil ) then
               if ( checkDB ) then TitanPals_DebugUtils( "info", "Init", LB["TITAN_PALS_ARRAY"]:format( "TitanPalsLists" ) ); end
               TitanPalsLists = {};
          end
          if ( not TitanPalsAlts or TitanPalsAlts == nil ) then
               if ( checkDB ) then TitanPals_DebugUtils( "info", "Init", LB["TITAN_PALS_ARRAY"]:format( "TitanPalsAlts" ) ); end
               TitanPalsAlts = {};
          end
	  if ( not TitanPalsStaticArrays or TitanPalsStaticArrays == nil ) then
               if ( checkDB ) then TitanPals_DebugUtils( "info", "Init", LB["TITAN_PALS_STATICARRAY_FIXED1"]:format( "TitanPalsStaticArrays" ) ); end
               TitanPalsStaticArrays = {};
          end
	  if ( not TitanPalsStaticArrays.presets or TitanPalsStaticArrays.presets == nil ) then
               if ( checkDB ) then TitanPals_DebugUtils( "info", "Init", LB["TITAN_PALS_STATICARRAY_FIXED2"]:format( "presets" ) ); end
               TitanPalsStaticArrays.presets = {
                    { name = "Style #1", value = "!s (!l !c) !p ~ !n !z", },
                    { name = "Style #2", value = "!s (!l) !uc ~ !n !z", },
                    { name = "Style #3", value = "!s (!l) !p - !c !z ~ !n", },
                    { name = "Style #4", value = "!s (!l) !c - !p !z ~ !n", },
                    { name = "Style #5", value = "!s (!l) !uc !z ~ !n", },
                    { name = "Style #6", value = "!s !p (!l) - !c !n ~ !z", },
                    { name = "Style #7", value = "!s !z (!l) - !c !n ~ !p", },
                    { name = "Style #8", value = "!s !c (!l) !z !n ~ !p", },
               };
          end
	  if ( not TitanPalsStaticArrays.sTypes or TitanPalsStaticArrays.sTypes == nil ) then
               if ( checkDB ) then TitanPals_DebugUtils( "info", "Init", LB["TITAN_PALS_STATICARRAY_FIXED2"]:format( "sTypes" ) ); end
               TitanPalsStaticArrays.sTypes = {
                    { name = ( "<%s>" ):format( LB["TITAN_PALS_CONFIG_AWAY"] ), value = ( "<%s>" ):format( LB["TITAN_PALS_CONFIG_AWAY"] ), },
                    { name = "<AFK>", value = "<AFK>" },
                    { name = "<A>", value = "<A>" },
                    { name = ( "(%s)" ):format( LB["TITAN_PALS_CONFIG_AWAY"] ), value = ( "(%s)" ):format( LB["TITAN_PALS_CONFIG_AWAY"] ), },
                    { name = "(AFK)", value = "(AFK)" },
                    { name = "(A)", value = "(A)" },
                    { name = ( "[%s]" ):format( LB["TITAN_PALS_CONFIG_AWAY"] ), value = ( "[%s]" ):format( LB["TITAN_PALS_CONFIG_AWAY"] ), },
                    { name = "[AFK]", value = "[AFK]" },
                    { name = "[A]", value = "[A]" },
               };
          end
          if ( not TitanPalsStaticArrays.dTypes or TitanPalsStaticArrays.dTypes == nil ) then
               if ( checkDB ) then TitanPals_DebugUtils( "info", "Init", LB["TITAN_PALS_STATICARRAY_FIXED2"]:format( "dTypes" ) ); end
               TitanPalsStaticArrays.dTypes = {
                    { name = ( "<%s>" ):format( LB["TITAN_PALS_CONFIG_DND"] ), value = ( "<%s>" ):format( LB["TITAN_PALS_CONFIG_DND"] ), },
                    { name = ( "<%s>" ):format( LB["TITAN_PALS_CONFIG_BUSY"] ), value = ( "<%s>" ):format( LB["TITAN_PALS_CONFIG_BUSY"] ), },
                    { name = ( "[%s]" ):format( LB["TITAN_PALS_CONFIG_DND"] ), value = ( "[%s]" ):format( LB["TITAN_PALS_CONFIG_DND"] ), },
                    { name = ( "[%s]" ):format( LB["TITAN_PALS_CONFIG_BUSY"] ), value = ( "[%s]" ):format( LB["TITAN_PALS_CONFIG_BUSY"] ), },
                    { name = ( "(%s)" ):format( LB["TITAN_PALS_CONFIG_DND"] ), value = ( "(%s)" ):format( LB["TITAN_PALS_CONFIG_DND"] ), },
                    { name = ( "(%s)" ):format( LB["TITAN_PALS_CONFIG_BUSY"] ), value = ( "(%s)" ):format( LB["TITAN_PALS_CONFIG_BUSY"] ), },
               };
          end
	  if ( not TitanPalsStaticArrays.realidformats or TitanPalsStaticArrays.realidformats == nil ) then
               if ( checkDB ) then TitanPals_DebugUtils( "info", "Init", LB["TITAN_PALS_ARRAY_FIXED"]:format( "realidformats" ) ); end
               TitanPalsStaticArrays.realidformats = {
                    { name = "Format #1", value = "!cn" },
                    { name = "Format #2", value = "!cn - !rn" },
                    { name = "Format #3", value = "!sn/!cn" },
                    { name = "Format #4", value = "!ln/!cn" },
                    { name = "Format #5", value = "!fn/!cn" },
                    { name = "Format #6", value = "!fn/!cn - !rn" },
                    { name = "Format #7", value = "!fn ( !cn )" },
                    { name = "Format #8", value = "!cn ( !fn )" },
               };
          end
          if ( not TitanPals.notesAdd or TitanPals.notesAdd == nil ) then 
               if ( checkDB ) then TitanPals_DebugUtils( "info", "Init", LB["TITAN_PALS_ARRAY_FIXED"]:format( "notesAdd" ) ); end
               TitanPals.notesAdd = {};
          end
          if ( not TitanPals.Debug or TitanPals.Debug == nil ) then
               if ( checkDB ) then TitanPals_DebugUtils( "info", "Init", LB["TITAN_PALS_ARRAY_FIXED"]:format( "Debug" ) ); end
               TitanPals.Debug = {
                    State = false,
                    Event = false,
                    LogEvent = false,
                    dLine = "",
               };
          end
          if ( not TitanPals.AddAuth or TitanPals.AddAuth == nil ) then
               if ( checkDB ) then TitanPals_DebugUtils( "info", "Init", LB["TITAN_PALS_ARRAY_FIXED"]:format( "AddAuth" ) ); end
               TitanPals.AddAuth = {};
          end
          if ( not TitanPals.Settings or TitanPals.Settings == nil ) then
               if ( checkDB ) then TitanPals_DebugUtils( "info", "Init", LB["TITAN_PALS_ARRAY_FIXED"]:format( "Settings" ) ); end
               TitanPals.Settings = {
                    ShowIgnored = false,
                    ShowMem = true,
	            ShowBNTooltip = true,
                    UpDateDB = true,
                    DisplayB = true,
                    ShowMem = true,
                    NoAlts = true,
                    TFormat = "!s (!l !c) !p ~ !n !z",
                    SFormat = ( "<%s>" ):format( LB["TITAN_PALS_CONFIG_AWAY"] ),
                    DFormat = ( "<%s>" ):format( LB["TITAN_PALS_CONFIG_BUSY"] ),
                    dDefault = LB["TITAN_PALS_CONFIG_AWAY"],
                    RealIDFormat = "!cn",
                    Version = LB["TITAN_PALS_CORE_VERSION"],
                    ArrayVersion = LB["TITAN_PALS_CORE_DBVER"],
               };
          end
          if ( not TitanPals.Temp or TitanPals.Temp == nil ) then
               if ( checkDB ) then TitanPals_DebugUtils( "info", "Init", LB["TITAN_PALS_ARRAY_FIXED"]:format( "Temp" ) ); end
               TitanPals.Temp = {};
          end
          if ( not TitanPals.toonEdit or TitanPals.toonEdit == nil ) then
               if ( checkDB ) then TitanPals_DebugUtils( "info", "Init", LB["TITAN_PALS_ARRAY_FIXED"]:format( "toonEdit" ) ); end
               TitanPals.toonEdit = {
                    toonName = LB["TITAN_PALS_CONFIG_SELECT"],
                    toonClass = LB["TITAN_PALS_CONFIG_UNKNOWN"],
                    toonLevel = 0,
                    toonAlt = LB["TITAN_PALS_CONFIG_SELECT"],
               };
          end
          TitanPalsInit = true;
          if ( checkDB ) then TitanPals_DebugUtils( "info", "reset", LB["TITAN_PALS_MENU_CHECKDB_FINSIHED"] ); end
     end
     if ( not TitanPals.Profile or TitanPals.Profile == nil ) then
          TitanPals.Profile = {};
     end
     TitanPals.Profile = {
          Player = LB["TITAN_PALS_CONFIG_UNKNOWN"],
          Faction = LB["TITAN_PALS_CONFIG_UNKNOWN"],
          Realm = LB["TITAN_PALS_CONFIG_UNKNOWN"],
          Level = LB["TITAN_PALS_CONFIG_UNKNOWN"],
          Class = LB["TITAN_PALS_CONFIG_UNKNOWN"],
     };
     TitanPals_CheckUpdate( checkDB );
end

-- **************************************************************************
-- NAME : TitanPals_CheckUpdate( checkDB )
-- DESC : Event Handler
-- **************************************************************************
function TitanPals_CheckUpdate( checkDB )
     if ( TitanPals.Settings.Version ~= LB["TITAN_PALS_CORE_VERSION"] ) then
          TitanPals_DebugUtils( "info", "Init", LB["TITAN_PALS_ADDON_UPDATE"]:format( LB["TITAN_PALS_CORE_VERSION"] ) );
          TitanPals.Settings.Version = LB["TITAN_PALS_CORE_VERSION"];
     end
     if ( TitanPals.Settings.ArrayVersion ~= LB["TITAN_PALS_CORE_DBVER"] ) then
          TitanPals_DebugUtils( "info", "Init", LB["TITAN_PALS_ARRAY_UPDATE"]:format( LB["TITAN_PALS_CORE_DBVER"] ) );
          TitanPals.authors = nil;
          TitanPals.Master = nil;
          TitanPals.RealIDs = nil;
          TitanPals.Init = nil;
          TitanPals.presets = nil;
          TitanPals.sTypes = nil;
          TitanPals.dTypes = nil;
          TitanPals.realidformats = nil;
	  TitanPals.Alts = nil;
	  TitanPals.Lists = nil;
          TitanPals.Settings.ArrayVersion = LB["TITAN_PALS_CORE_DBVER"];
     end
end

-- **************************************************************************
-- NAME : TitanPanelPalsButton_OnEvent()
-- DESC : Event Handler
-- **************************************************************************
function TitanPanelPalsButton_OnEvent( self, event, ... )
     local arg1 = ...
     if ( TItanPalsInit and TitanPals.Debug.Event ) then TitanPals_DebugUtils( "bug", "OnEvent", ( "[%s]" ):format ( TitanPals_ColorUtils( "GetCText", "gray", event ) ) ); end
     if ( event == "ADDON_LOADED" and arg1 == "TitanPals" ) then
          TitanPals_Init( "init" );
          if ( not BNFeaturesEnabled() ) then TitanPals.Settings.ShowBNTooltip = false; end
     elseif ( event == "PLAYER_ENTERING_WORLD" ) then
          if ( TitanPals.Settings.DisplayB ) then TitanPals_CoreUtils( "DisplayB" ); end
          TitanPals_SetUser();
     elseif ( event == "BN_FRIEND_ACCOUNT_ONLINE" or event == "BN_FRIEND_ACCOUNT_OFFLINE" or event == "FRIENDLIST_UPDATE" or event == "IGNORELIST_UPDATE" )then
          TitanPanelButton_UpdateButton( LB["TITAN_PALS_CORE_ID"] );
          TitanPanelButton_UpdateTooltip();
     end
end

-- **************************************************************************
-- NAME : TitanPanelPalsButton_GetButtonText()
-- DESC : Build Button Text
-- **************************************************************************
function TitanPanelPalsButton_GetButtonText()
     local NumIgnore = GetNumIgnores();
     local NumPals, NumPalsOnline = GetNumFriends();
     local _, BNetCount = BNGetNumFriends();
     local buttonRichText
     buttonRichText = TitanPals_ColorUtils( "GetCText", "green", tonumber( NumPalsOnline ) );
     if ( TitanPals.Settings.ShowBNTooltip ) then
          buttonRichText = ( "%s/%s" ):format( buttonRichText, TitanPals_ColorUtils( "GetCText", "blue", BNetCount ) );
     end
     if ( TitanPals.Settings.ShowIgnored ) then 
          buttonRichText = ( "%s/%s" ):format( buttonRichText, TitanPals_ColorUtils( "GetCText", "red", NumIgnore ) );
     end
     return LB["TITAN_PALS_BUTTON_LABEL"], buttonRichText;
end

-- **************************************************************************
-- NAME : TitanPanelPalsButton_OnClick()
-- DESC : Toggles Friends Dialog
-- **************************************************************************
function TitanPanelPalsButton_OnClick( self, button )
     if ( button == "LeftButton" ) then
          ToggleFriendsFrame( 1 );
     else
          TitanPanelButton_OnClick( self, button );
     end
end

-- **************************************************************************
-- NAME : TitanPals_SetUser()
-- DESC : Sets up the User for use with the data array
-- **************************************************************************
function TitanPals_SetUser()
     local Fac = UnitFactionGroup( "player" );
     local Rea = GetCVar( "realmName" );
     local Pal = GetUnitName( "player" );
     local Lev = UnitLevel( "player" );
     local Cla = UnitClass( "player" );
     if ( not TitanPals.Profile.Player or TitanPals.Profile.Player ~= Pal ) then TitanPals.Profile.Player = Pal; end
     if ( not TitanPals.Profile.Faction or TitanPals.Profile.Faction ~= Fac ) then TitanPals.Profile.Faction = Fac; end
     if ( not TitanPals.Profile.Level or TitanPals.Profile.Level ~= Lev ) then TitanPals.Profile.Level = tonumber( Lev ); end
     if ( not TitanPals.Profile.Class or TitanPals.Profile.Class ~= Cla ) then TitanPals.Profile.Class = Cla; end
     if ( not TitanPals.Profile.Realm or TitanPals.Profile.Realm~= Rea ) then TitanPals.Profile.Realm = Rea; end
     if ( not palsDB or palsDB ~= ( "%s:%s" ):format( Fac, Rea ) ) then palsDB = ( "%s:%s" ):format( Fac, Rea ); end
     if ( not palsAuthor or palsAuthor ~= ( "%s@%s" ):format( Pal, Rea ) ) then palsAuthor = ( "%s@%s" ):format( Pal, Rea ); end
     if ( not TitanPalsLists[palsDB] ) then TitanPalsLists[palsDB] = {}; end
     if ( not TitanPalsLists[palsDB][Pal] ) then TitanPalsLists[palsDB][Pal] = {}; end
     if ( TitanPalsLists[palsDB][Pal] ) then
          TitanPalsLists[palsDB][Pal].Class = Cla;
          TitanPalsLists[palsDB][Pal].Level = tonumber( Lev );
          TitanPalsLists[palsDB][Pal].Note = "na";
     end
     if ( not TitanPalsAlts[palsDB] ) then TitanPalsAlts[palsDB] = {}; end
     if ( not TitanPalsAlts[palsDB][Pal] ) then TitanPalsAlts[palsDB][Pal] = Cla; end
end

-- **************************************************************************
-- NAME : TitanPanelPals_SyncAlts()
-- DESC : This adds your alts to your friends list for things like mailing
-- **************************************************************************
function TitanPanelPals_SyncAlts()
     -- Alts to Pals List Syncing
     local np = GetNumFriends();
     local aIndex = TitanPalsAlts[palsDB];
     local fI, palsn, palsl, palsc, palsa, palsco, palss, palsno;
     local syncType = LB["TITAN_PALS_SYNC_ALTS_LABEL"];
     for n, v in pairs( aIndex ) do
          local tp = 0;
          local fI;
          for fI=1, np do
               palsn = GetFriendInfo( fI );
               if ( n == palsn ) then tp = 1; end
          end
          if ( tp == 0 and n ~= TitanPals.Profile.Player ) then
               TitanPals_DebugUtils( "info", syncType, LB["TITAN_PALS_SYNC_ALTS"]:format( n ) );
               AddFriend( n ); 
          end
     end
     TitanPals_DebugUtils( "info", syncType, LB["TITAN_PALS_SYNC_FINISHED"]:format( syncType ) );
end

-- **************************************************************************
-- NAME : TitanPanelPals_SyncAlts()
-- DESC : This syncs your alts friend to your friends list
-- **************************************************************************

function TitanPanelPals_SyncAltsFriends()
     local np = GetNumFriends();
     local iTable = TitanPalsLists[palsDB];
     local palsn, palsl, palsc, palsa, palsco, palss, palsno;
     local syncType = LB["TITAN_PALS_SYNC_FRIENDS_LABEL"];
     for n, v in pairs( iTable ) do
          if ( n ~= TitanPals.Profile.Player ) then
               local tp = 0;
               local fI;
               for fI = 1, np do
                    palsn = GetFriendInfo( fI );
                    if ( n == palsn ) then tp = 1; end
               end
               if ( tp == 0 and n ~= TitanPals.Profile.Player ) then
                    TitanPals_DebugUtils( "info", syncType, LB["TITAN_PALS_SYNC_FRIENDS"]:format( n ) );
                    AddFriend( n );
               end
	  end
     end
     TitanPals_DebugUtils( "info", syncType, LB["TITAN_PALS_SYNC_FINISHED"]:format( syncType ) );
end